﻿using System;
using System.Reactive.Linq;
using BulletSharp;

namespace VL.Bullet
{
    public static class BulletEvents
    {
        public class ContactArgs : EventArgs
        {
            public readonly ManifoldPoint ManifoldPoint;
            public readonly CollisionObjectWrapper CollisionObject0;
            public readonly int PartId0;
            public readonly int Index0;
            public readonly CollisionObjectWrapper CollisionObject1;
            public readonly int PartId1;
            public readonly int Index1;

            public ContactArgs(ManifoldPoint mfp, CollisionObjectWrapper cow0, int pid0, int id0, CollisionObjectWrapper cow1, int pid1, int id1)
            {
                ManifoldPoint = mfp;
                CollisionObject0 = cow0;
                PartId0 = pid0;
                Index0 = id0;
                CollisionObject1 = cow1;
                PartId1 = pid1;
                Index1 = id1;
            }
        }

        public static IObservable<ContactArgs> ContactAdded()
        {
            return Observable.FromEvent<ContactAddedEventHandler, ContactArgs>(handler =>
            {
                ContactAddedEventHandler caHandler = (mfp, cow0, pid0, id0, cow1, pid1, id1) =>
                {
                    handler(new ContactArgs(mfp, cow0, pid0, id0, cow1, pid1, id1));
                };

                return caHandler;
            },
                    caHandler => ManifoldPoint.ContactAdded += caHandler,
                    caHandler => ManifoldPoint.ContactAdded -= caHandler);
        }
    }
}
